<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="Docutils 0.21.2: https://docutils.sourceforge.io/" />
<title>hg resolve</title>
<link rel="stylesheet" href="../style.css" type="text/css" />
</head>
<body>
<div class="document" id="hg-resolve">
<span id="hg-resolve-1"></span>
<h1 class="title">hg resolve</h1>
<h2 class="subtitle" id="redo-merges-or-set-view-the-merge-status-of-files">redo merges or set/view the merge status of files</h2>

<div class="contents htmlonly topic" id="contents">
<p class="topic-title"><a class="reference internal" href="#top">Contents</a></p>
<ul class="simple">
<li><a class="reference internal" href="#synopsis" id="toc-entry-1">Synopsis</a></li>
<li><a class="reference internal" href="#description" id="toc-entry-2">Description</a></li>
<li><a class="reference internal" href="#options" id="toc-entry-3">Options</a></li>
</ul>
</div>
<div class="section" id="synopsis">
<h1><a class="toc-backref" href="#contents">Synopsis</a></h1>
<pre class="literal-block">
hg resolve [OPTION]... [FILE]...
</pre>
</div>
<div class="section" id="description">
<h1><a class="toc-backref" href="#contents">Description</a></h1>
<p>Merges with unresolved conflicts are often the result of
non-interactive merging using the <tt class="docutils literal">internal:merge</tt> configuration
setting, or a command-line merge tool like <tt class="docutils literal">diff3</tt>. The resolve
command is used to manage the files involved in a merge, after
<a class="reference external" href="hg-merge.html"><tt class="docutils literal">hg merge</tt></a> has been run, and before <a class="reference external" href="hg-commit.html"><tt class="docutils literal">hg commit</tt></a> is run (i.e. the
working directory must have two parents). See <a class="reference external" href="topic-merge-tools.html"><tt class="docutils literal">hg help
<span class="pre">merge-tools</span></tt></a> for information on configuring merge tools.</p>
<p>The resolve command can be used in the following ways:</p>
<ul class="simple">
<li><a class="reference external" href="hg-resolve.html"><tt class="docutils literal">hg resolve <span class="pre">[--re-merge]</span> <span class="pre">[--tool</span> TOOL] <span class="pre">FILE...</span></tt></a>: attempt to re-merge
the specified files, discarding any previous merge attempts. Re-merging
is not performed for files already marked as resolved. Use <tt class="docutils literal"><span class="pre">--all/-a</span></tt>
to select all unresolved files. <tt class="docutils literal"><span class="pre">--tool</span></tt> can be used to specify
the merge tool used for the given files. It overrides the HGMERGE
environment variable and your configuration files.  Previous file
contents are saved with a <tt class="docutils literal">.orig</tt> suffix.</li>
<li><a class="reference external" href="hg-resolve.html"><tt class="docutils literal">hg resolve <span class="pre">-m</span> [FILE]</tt></a>: mark a file as having been resolved
(e.g. after having manually fixed-up the files). The default is
to mark all unresolved files.</li>
<li><a class="reference external" href="hg-resolve.html"><tt class="docutils literal">hg resolve <span class="pre">-u</span> <span class="pre">[FILE]...</span></tt></a>: mark a file as unresolved. The
default is to mark all resolved files.</li>
<li><a class="reference external" href="hg-resolve.html"><tt class="docutils literal">hg resolve <span class="pre">-l</span></tt></a>: list files which had or still have conflicts.
In the printed list, <tt class="docutils literal">U</tt> = unresolved and <tt class="docutils literal">R</tt> = resolved.
You can use <tt class="docutils literal">set:unresolved()</tt> or <tt class="docutils literal">set:resolved()</tt> to filter
the list. See <a class="reference external" href="topic-filesets.html"><tt class="docutils literal">hg help filesets</tt></a> for details.</li>
</ul>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Mercurial will not let you commit files with unresolved merge
conflicts. You must use <a class="reference external" href="hg-resolve.html"><tt class="docutils literal">hg resolve <span class="pre">-m</span> ...</tt></a> before you can
commit after a conflicting merge.</p>
</div>
<div class="verbose docutils container">
<p>Template:</p>
<p>The following keywords are supported in addition to the common template
keywords and functions. See also <a class="reference external" href="hg.1.html#templates"><tt class="docutils literal">hg help templates</tt></a>.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field"><th class="field-name">mergestatus:</th><td class="field-body">String. Character denoting merge conflicts, <tt class="docutils literal">U</tt> or <tt class="docutils literal">R</tt>.</td>
</tr>
<tr class="field"><th class="field-name">path:</th><td class="field-body">String. Repository-absolute path of the file.</td>
</tr>
</tbody>
</table>
</div>
<p>Returns 0 on success, 1 if any files fail a resolve attempt.</p>
</div>
<div class="section" id="options">
<h1><a class="toc-backref" href="#contents">Options</a></h1>
<table class="docutils option-list" frame="void" rules="none">
<col class="option" />
<col class="description" />
<tbody valign="top">
<tr><td class="option-group">
<kbd><span class="option">-a</span>, <span class="option">--all</span></kbd></td>
<td>select all unresolved files</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-l</span>, <span class="option">--list</span></kbd></td>
<td>list state of files needing merge</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-m</span>, <span class="option">--mark</span></kbd></td>
<td>mark files as resolved</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-u</span>, <span class="option">--unmark</span></kbd></td>
<td>mark files as unresolved</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-n</span>, <span class="option">--no-status</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>hide status prefix</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--re-merge</span></kbd></td>
<td>re-merge files</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-t</span>, <span class="option">--tool <var>&lt;TOOL&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>specify merge tool</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-I</span>, <span class="option">--include <var>&lt;PATTERN[+]&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>include names matching the given patterns</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-X</span>, <span class="option">--exclude <var>&lt;PATTERN[+]&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>exclude names matching the given patterns</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-T</span>, <span class="option">--template <var>&lt;TEMPLATE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>display with template</td></tr>
</tbody>
</table>
<p>[+] marked option can be specified multiple times</p>
</div>
</div>
</body>
</html>
